/*
Copyright 2018 Ultimaker

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/Ultimaker/gcp-operator/pkg/apis/gcp/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeGCPCloudSQLInstances implements GCPCloudSQLInstanceInterface
type FakeGCPCloudSQLInstances struct {
	Fake *FakeGcpV1alpha1
	ns   string
}

var gcpcloudsqlinstancesResource = schema.GroupVersionResource{Group: "gcp.ultimaker.com", Version: "v1alpha1", Resource: "gcpcloudsqlinstances"}

var gcpcloudsqlinstancesKind = schema.GroupVersionKind{Group: "gcp.ultimaker.com", Version: "v1alpha1", Kind: "GCPCloudSQLInstance"}

// Get takes name of the gCPCloudSQLInstance, and returns the corresponding gCPCloudSQLInstance object, and an error if there is any.
func (c *FakeGCPCloudSQLInstances) Get(name string, options v1.GetOptions) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(gcpcloudsqlinstancesResource, c.ns, name), &v1alpha1.GCPCloudSQLInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GCPCloudSQLInstance), err
}

// List takes label and field selectors, and returns the list of GCPCloudSQLInstances that match those selectors.
func (c *FakeGCPCloudSQLInstances) List(opts v1.ListOptions) (result *v1alpha1.GCPCloudSQLInstanceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(gcpcloudsqlinstancesResource, gcpcloudsqlinstancesKind, c.ns, opts), &v1alpha1.GCPCloudSQLInstanceList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.GCPCloudSQLInstanceList{ListMeta: obj.(*v1alpha1.GCPCloudSQLInstanceList).ListMeta}
	for _, item := range obj.(*v1alpha1.GCPCloudSQLInstanceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested gCPCloudSQLInstances.
func (c *FakeGCPCloudSQLInstances) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(gcpcloudsqlinstancesResource, c.ns, opts))

}

// Create takes the representation of a gCPCloudSQLInstance and creates it.  Returns the server's representation of the gCPCloudSQLInstance, and an error, if there is any.
func (c *FakeGCPCloudSQLInstances) Create(gCPCloudSQLInstance *v1alpha1.GCPCloudSQLInstance) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(gcpcloudsqlinstancesResource, c.ns, gCPCloudSQLInstance), &v1alpha1.GCPCloudSQLInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GCPCloudSQLInstance), err
}

// Update takes the representation of a gCPCloudSQLInstance and updates it. Returns the server's representation of the gCPCloudSQLInstance, and an error, if there is any.
func (c *FakeGCPCloudSQLInstances) Update(gCPCloudSQLInstance *v1alpha1.GCPCloudSQLInstance) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(gcpcloudsqlinstancesResource, c.ns, gCPCloudSQLInstance), &v1alpha1.GCPCloudSQLInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GCPCloudSQLInstance), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeGCPCloudSQLInstances) UpdateStatus(gCPCloudSQLInstance *v1alpha1.GCPCloudSQLInstance) (*v1alpha1.GCPCloudSQLInstance, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(gcpcloudsqlinstancesResource, "status", c.ns, gCPCloudSQLInstance), &v1alpha1.GCPCloudSQLInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GCPCloudSQLInstance), err
}

// Delete takes name of the gCPCloudSQLInstance and deletes it. Returns an error if one occurs.
func (c *FakeGCPCloudSQLInstances) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(gcpcloudsqlinstancesResource, c.ns, name), &v1alpha1.GCPCloudSQLInstance{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeGCPCloudSQLInstances) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(gcpcloudsqlinstancesResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.GCPCloudSQLInstanceList{})
	return err
}

// Patch applies the patch and returns the patched gCPCloudSQLInstance.
func (c *FakeGCPCloudSQLInstances) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.GCPCloudSQLInstance, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(gcpcloudsqlinstancesResource, c.ns, name, data, subresources...), &v1alpha1.GCPCloudSQLInstance{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.GCPCloudSQLInstance), err
}
